import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class AFaire{
    public static void main(String args[]){
	new PremDessin(" ");
    }
}

   

class PremDessin
    extends JFrame
    implements MouseListener, MouseMotionListener, KeyListener{

    private int x,y,xm,ym;
    private int nbPoints,nbCircles,nbDisks,nbFrames;
    private Point[] points;
    private Point[] circles;
    private Point[] disks;
    private Point[] frames;

    PremDessin(String titre){
	super(titre);
	setBackground(Color.orange);
	setSize(800,500);
	setVisible(true);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	addMouseListener(this);
	addMouseMotionListener(this);
	addKeyListener(this);
	x = xm = 400;
	y = ym = 250;
	nbPoints=nbCircles=nbDisks=nbFrames=0;
	points=new Point[1];
	circles=new Point[1];
	disks=new Point[1];
	frames=new Point[1];
    }


    public void ajoutePoint(int x,int y){
	if(nbPoints==points.length){
	    Point[] temp=new Point[nbPoints*2];
	    for(int i=0;i<nbPoints;i++){
		temp[i]=points[i];
	    }
	    points=temp;
	}
	points[nbPoints]=new Point(x,y);
	nbPoints++;
    }

    public void ajouteCircle(int x,int y){
	if(nbCircles==circles.length){
	    Point[] temp=new Point[nbCircles*2];
	    for(int i=0;i<nbCircles;i++){
		temp[i]=circles[i];
	    }
	    circles=temp;
	}
	circles[nbCircles]=new Point(x,y);
	nbCircles++;
    }

    public void ajouteDisk(int x,int y){
	if(nbDisks==disks.length){
	    Point[] temp=new Point[nbDisks*2];
	    for(int i=0;i<nbDisks;i++){
		temp[i]=disks[i];
	    }
	    disks=temp;
	}
	disks[nbDisks]=new Point(x,y);
	nbDisks++;
    }

    public void ajouteFrame(int x,int y){
	if(nbFrames==frames.length){
	    Point[] temp=new Point[nbFrames*2];
	    for(int i=0;i<nbFrames;i++){
		temp[i]=frames[i];
	    }
	    frames=temp;
	}
	frames[nbFrames]=new Point(x,y);
	nbFrames++;
    }


    public void paint(Graphics g) {
   	g.drawString("Bonjour !!!",50,50);
	x=400;
	y=250;
	for(int i=0;i<nbPoints;i++){
	    getGraphics().drawLine(x, y, points[i].x, points[i].y);
	    x=points[i].x;
	    y=points[i].y;
	}
	for(int i=0;i<nbCircles;i++){
	    getGraphics().drawOval(circles[i].x, circles[i].y, 60, 60);
	}
	for(int i=0;i<nbDisks;i++){
	    getGraphics().fillOval(disks[i].x, disks[i].y, 30, 30);
	}
	for(int i=0;i<nbFrames;i++){
	    getGraphics().drawRect(frames[i].x, frames[i].y, 80, 90);
	}
	xm=x;
	ym=y;
    }

    public void mousePressed(MouseEvent e) {
	int xs = e.getX();
	int ys = e.getY();
	getGraphics().drawLine(x,y,xs,ys);
	x = xs;
	y = ys;
	ajoutePoint(x,y);
    }

    public void mouseReleased(MouseEvent e) {
	xm = e.getX();
	ym = e.getY();
	
    }

    public void mouseClicked(MouseEvent e) {
	int xs = e.getX();
	int ys = e.getY();
	getGraphics().drawLine(x,y,xs,ys);
	x = xm = xs;
	y = ym = ys;
	ajoutePoint(x,y);
   }

    public void mouseMoved(MouseEvent e) {
	xm = e.getX();
	ym = e.getY();
    }

    public void mouseDragged(MouseEvent e) {
	int xs = e.getX();
	int ys = e.getY();
	getGraphics().drawLine(x,y,xs,ys);
	x = xs;
	y = ys;
	ajoutePoint(x,y);
    }

    public void mouseEntered(MouseEvent e) {
	int xs = e.getX();
	int ys = e.getY();
	xm=xs;
	ym=ys;
    }

    public void mouseExited(MouseEvent e) {
    }

    public void keyPressed(KeyEvent e) {
	int i = e.getKeyCode() ;
	if (e.isControlDown() && i == KeyEvent.VK_C){ 
	    getGraphics().drawOval(xm, ym, 60, 60);
	    ajouteCircle(xm,ym);
	}
	if (e.isControlDown() && e.isAltDown() && e.isShiftDown() && i == KeyEvent.VK_D){ 
	    getGraphics().fillOval(xm, ym, 30, 30);
	    ajouteDisk(xm,ym);
	}
	if (e.isAltDown()  && i == KeyEvent.VK_R){
	    getGraphics().drawRect(xm, ym, 80, 90);
	    ajouteFrame(xm,ym);
	}
    }

    public void keyTyped(KeyEvent e) {
    }

    public void keyReleased(KeyEvent e) {
    }

   
}